/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         c_parse
#define yylex           c_lex
#define yyerror         c_error
#define yydebug         c_debug
#define yynerrs         c_nerrs

#define yylval          c_lval
#define yychar          c_char

/* Copy the first part of user declarations.  */
#line 10 "./configparser.y" /* yacc.c:339  */

#include "config.h"

#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>

#include "options.h"
#include "util.h"
#include "dname.h"
#include "tsig.h"
#include "rrl.h"

int yylex(void);

#ifdef __cplusplus
extern "C"
#endif

/* these need to be global, otherwise they cannot be used inside yacc */
extern config_parser_state_type *cfg_parser;

static void append_acl(struct acl_options **list, struct acl_options *acl);
static void add_to_last_acl(struct acl_options **list, char *ac);
static int parse_boolean(const char *str, int *bln);
static int parse_expire_expr(const char *str, long long *num, uint8_t *expr);
static int parse_number(const char *str, long long *num);
static int parse_range(const char *str, long long *low, long long *high);

struct component {
	struct component *next;
	char *str;
};


#line 111 "configparser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "configparser.h".  */
#ifndef YY_C_CONFIGPARSER_H_INCLUDED
# define YY_C_CONFIGPARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int c_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    STRING = 258,
    VAR_SERVER = 259,
    VAR_SERVER_COUNT = 260,
    VAR_IP_ADDRESS = 261,
    VAR_IP_TRANSPARENT = 262,
    VAR_IP_FREEBIND = 263,
    VAR_REUSEPORT = 264,
    VAR_SEND_BUFFER_SIZE = 265,
    VAR_RECEIVE_BUFFER_SIZE = 266,
    VAR_DEBUG_MODE = 267,
    VAR_IP4_ONLY = 268,
    VAR_IP6_ONLY = 269,
    VAR_DO_IP4 = 270,
    VAR_DO_IP6 = 271,
    VAR_PORT = 272,
    VAR_USE_SYSTEMD = 273,
    VAR_VERBOSITY = 274,
    VAR_USERNAME = 275,
    VAR_CHROOT = 276,
    VAR_ZONESDIR = 277,
    VAR_ZONELISTFILE = 278,
    VAR_DATABASE = 279,
    VAR_LOGFILE = 280,
    VAR_LOG_ONLY_SYSLOG = 281,
    VAR_PIDFILE = 282,
    VAR_DIFFFILE = 283,
    VAR_XFRDFILE = 284,
    VAR_XFRDIR = 285,
    VAR_HIDE_VERSION = 286,
    VAR_HIDE_IDENTITY = 287,
    VAR_VERSION = 288,
    VAR_IDENTITY = 289,
    VAR_NSID = 290,
    VAR_TCP_COUNT = 291,
    VAR_TCP_REJECT_OVERFLOW = 292,
    VAR_TCP_QUERY_COUNT = 293,
    VAR_TCP_TIMEOUT = 294,
    VAR_TCP_MSS = 295,
    VAR_OUTGOING_TCP_MSS = 296,
    VAR_IPV4_EDNS_SIZE = 297,
    VAR_IPV6_EDNS_SIZE = 298,
    VAR_STATISTICS = 299,
    VAR_XFRD_RELOAD_TIMEOUT = 300,
    VAR_LOG_TIME_ASCII = 301,
    VAR_ROUND_ROBIN = 302,
    VAR_MINIMAL_RESPONSES = 303,
    VAR_CONFINE_TO_ZONE = 304,
    VAR_REFUSE_ANY = 305,
    VAR_ZONEFILES_CHECK = 306,
    VAR_ZONEFILES_WRITE = 307,
    VAR_RRL_SIZE = 308,
    VAR_RRL_RATELIMIT = 309,
    VAR_RRL_SLIP = 310,
    VAR_RRL_IPV4_PREFIX_LENGTH = 311,
    VAR_RRL_IPV6_PREFIX_LENGTH = 312,
    VAR_RRL_WHITELIST_RATELIMIT = 313,
    VAR_TLS_SERVICE_KEY = 314,
    VAR_TLS_SERVICE_PEM = 315,
    VAR_TLS_SERVICE_OCSP = 316,
    VAR_TLS_PORT = 317,
    VAR_TLS_CERT_BUNDLE = 318,
    VAR_CPU_AFFINITY = 319,
    VAR_XFRD_CPU_AFFINITY = 320,
    VAR_SERVER_CPU_AFFINITY = 321,
    VAR_DROP_UPDATES = 322,
    VAR_XFRD_TCP_MAX = 323,
    VAR_XFRD_TCP_PIPELINE = 324,
    VAR_DNSTAP = 325,
    VAR_DNSTAP_ENABLE = 326,
    VAR_DNSTAP_SOCKET_PATH = 327,
    VAR_DNSTAP_SEND_IDENTITY = 328,
    VAR_DNSTAP_SEND_VERSION = 329,
    VAR_DNSTAP_IDENTITY = 330,
    VAR_DNSTAP_VERSION = 331,
    VAR_DNSTAP_LOG_AUTH_QUERY_MESSAGES = 332,
    VAR_DNSTAP_LOG_AUTH_RESPONSE_MESSAGES = 333,
    VAR_REMOTE_CONTROL = 334,
    VAR_CONTROL_ENABLE = 335,
    VAR_CONTROL_INTERFACE = 336,
    VAR_CONTROL_PORT = 337,
    VAR_SERVER_KEY_FILE = 338,
    VAR_SERVER_CERT_FILE = 339,
    VAR_CONTROL_KEY_FILE = 340,
    VAR_CONTROL_CERT_FILE = 341,
    VAR_KEY = 342,
    VAR_ALGORITHM = 343,
    VAR_SECRET = 344,
    VAR_TLS_AUTH = 345,
    VAR_TLS_AUTH_DOMAIN_NAME = 346,
    VAR_TLS_AUTH_CLIENT_CERT = 347,
    VAR_TLS_AUTH_CLIENT_KEY = 348,
    VAR_TLS_AUTH_CLIENT_KEY_PW = 349,
    VAR_PATTERN = 350,
    VAR_NAME = 351,
    VAR_ZONEFILE = 352,
    VAR_NOTIFY = 353,
    VAR_PROVIDE_XFR = 354,
    VAR_ALLOW_QUERY = 355,
    VAR_AXFR = 356,
    VAR_UDP = 357,
    VAR_NOTIFY_RETRY = 358,
    VAR_ALLOW_NOTIFY = 359,
    VAR_REQUEST_XFR = 360,
    VAR_ALLOW_AXFR_FALLBACK = 361,
    VAR_OUTGOING_INTERFACE = 362,
    VAR_ANSWER_COOKIE = 363,
    VAR_COOKIE_SECRET = 364,
    VAR_COOKIE_SECRET_FILE = 365,
    VAR_MAX_REFRESH_TIME = 366,
    VAR_MIN_REFRESH_TIME = 367,
    VAR_MAX_RETRY_TIME = 368,
    VAR_MIN_RETRY_TIME = 369,
    VAR_MIN_EXPIRE_TIME = 370,
    VAR_MULTI_MASTER_CHECK = 371,
    VAR_SIZE_LIMIT_XFR = 372,
    VAR_ZONESTATS = 373,
    VAR_INCLUDE_PATTERN = 374,
    VAR_STORE_IXFR = 375,
    VAR_IXFR_SIZE = 376,
    VAR_IXFR_NUMBER = 377,
    VAR_CREATE_IXFR = 378,
    VAR_ZONE = 379,
    VAR_RRL_WHITELIST = 380,
    VAR_SERVERS = 381,
    VAR_BINDTODEVICE = 382,
    VAR_SETFIB = 383,
    VAR_VERIFY = 384,
    VAR_ENABLE = 385,
    VAR_VERIFY_ZONE = 386,
    VAR_VERIFY_ZONES = 387,
    VAR_VERIFIER = 388,
    VAR_VERIFIER_COUNT = 389,
    VAR_VERIFIER_FEED_ZONE = 390,
    VAR_VERIFIER_TIMEOUT = 391
  };
#endif
/* Tokens.  */
#define STRING 258
#define VAR_SERVER 259
#define VAR_SERVER_COUNT 260
#define VAR_IP_ADDRESS 261
#define VAR_IP_TRANSPARENT 262
#define VAR_IP_FREEBIND 263
#define VAR_REUSEPORT 264
#define VAR_SEND_BUFFER_SIZE 265
#define VAR_RECEIVE_BUFFER_SIZE 266
#define VAR_DEBUG_MODE 267
#define VAR_IP4_ONLY 268
#define VAR_IP6_ONLY 269
#define VAR_DO_IP4 270
#define VAR_DO_IP6 271
#define VAR_PORT 272
#define VAR_USE_SYSTEMD 273
#define VAR_VERBOSITY 274
#define VAR_USERNAME 275
#define VAR_CHROOT 276
#define VAR_ZONESDIR 277
#define VAR_ZONELISTFILE 278
#define VAR_DATABASE 279
#define VAR_LOGFILE 280
#define VAR_LOG_ONLY_SYSLOG 281
#define VAR_PIDFILE 282
#define VAR_DIFFFILE 283
#define VAR_XFRDFILE 284
#define VAR_XFRDIR 285
#define VAR_HIDE_VERSION 286
#define VAR_HIDE_IDENTITY 287
#define VAR_VERSION 288
#define VAR_IDENTITY 289
#define VAR_NSID 290
#define VAR_TCP_COUNT 291
#define VAR_TCP_REJECT_OVERFLOW 292
#define VAR_TCP_QUERY_COUNT 293
#define VAR_TCP_TIMEOUT 294
#define VAR_TCP_MSS 295
#define VAR_OUTGOING_TCP_MSS 296
#define VAR_IPV4_EDNS_SIZE 297
#define VAR_IPV6_EDNS_SIZE 298
#define VAR_STATISTICS 299
#define VAR_XFRD_RELOAD_TIMEOUT 300
#define VAR_LOG_TIME_ASCII 301
#define VAR_ROUND_ROBIN 302
#define VAR_MINIMAL_RESPONSES 303
#define VAR_CONFINE_TO_ZONE 304
#define VAR_REFUSE_ANY 305
#define VAR_ZONEFILES_CHECK 306
#define VAR_ZONEFILES_WRITE 307
#define VAR_RRL_SIZE 308
#define VAR_RRL_RATELIMIT 309
#define VAR_RRL_SLIP 310
#define VAR_RRL_IPV4_PREFIX_LENGTH 311
#define VAR_RRL_IPV6_PREFIX_LENGTH 312
#define VAR_RRL_WHITELIST_RATELIMIT 313
#define VAR_TLS_SERVICE_KEY 314
#define VAR_TLS_SERVICE_PEM 315
#define VAR_TLS_SERVICE_OCSP 316
#define VAR_TLS_PORT 317
#define VAR_TLS_CERT_BUNDLE 318
#define VAR_CPU_AFFINITY 319
#define VAR_XFRD_CPU_AFFINITY 320
#define VAR_SERVER_CPU_AFFINITY 321
#define VAR_DROP_UPDATES 322
#define VAR_XFRD_TCP_MAX 323
#define VAR_XFRD_TCP_PIPELINE 324
#define VAR_DNSTAP 325
#define VAR_DNSTAP_ENABLE 326
#define VAR_DNSTAP_SOCKET_PATH 327
#define VAR_DNSTAP_SEND_IDENTITY 328
#define VAR_DNSTAP_SEND_VERSION 329
#define VAR_DNSTAP_IDENTITY 330
#define VAR_DNSTAP_VERSION 331
#define VAR_DNSTAP_LOG_AUTH_QUERY_MESSAGES 332
#define VAR_DNSTAP_LOG_AUTH_RESPONSE_MESSAGES 333
#define VAR_REMOTE_CONTROL 334
#define VAR_CONTROL_ENABLE 335
#define VAR_CONTROL_INTERFACE 336
#define VAR_CONTROL_PORT 337
#define VAR_SERVER_KEY_FILE 338
#define VAR_SERVER_CERT_FILE 339
#define VAR_CONTROL_KEY_FILE 340
#define VAR_CONTROL_CERT_FILE 341
#define VAR_KEY 342
#define VAR_ALGORITHM 343
#define VAR_SECRET 344
#define VAR_TLS_AUTH 345
#define VAR_TLS_AUTH_DOMAIN_NAME 346
#define VAR_TLS_AUTH_CLIENT_CERT 347
#define VAR_TLS_AUTH_CLIENT_KEY 348
#define VAR_TLS_AUTH_CLIENT_KEY_PW 349
#define VAR_PATTERN 350
#define VAR_NAME 351
#define VAR_ZONEFILE 352
#define VAR_NOTIFY 353
#define VAR_PROVIDE_XFR 354
#define VAR_ALLOW_QUERY 355
#define VAR_AXFR 356
#define VAR_UDP 357
#define VAR_NOTIFY_RETRY 358
#define VAR_ALLOW_NOTIFY 359
#define VAR_REQUEST_XFR 360
#define VAR_ALLOW_AXFR_FALLBACK 361
#define VAR_OUTGOING_INTERFACE 362
#define VAR_ANSWER_COOKIE 363
#define VAR_COOKIE_SECRET 364
#define VAR_COOKIE_SECRET_FILE 365
#define VAR_MAX_REFRESH_TIME 366
#define VAR_MIN_REFRESH_TIME 367
#define VAR_MAX_RETRY_TIME 368
#define VAR_MIN_RETRY_TIME 369
#define VAR_MIN_EXPIRE_TIME 370
#define VAR_MULTI_MASTER_CHECK 371
#define VAR_SIZE_LIMIT_XFR 372
#define VAR_ZONESTATS 373
#define VAR_INCLUDE_PATTERN 374
#define VAR_STORE_IXFR 375
#define VAR_IXFR_SIZE 376
#define VAR_IXFR_NUMBER 377
#define VAR_CREATE_IXFR 378
#define VAR_ZONE 379
#define VAR_RRL_WHITELIST 380
#define VAR_SERVERS 381
#define VAR_BINDTODEVICE 382
#define VAR_SETFIB 383
#define VAR_VERIFY 384
#define VAR_ENABLE 385
#define VAR_VERIFY_ZONE 386
#define VAR_VERIFY_ZONES 387
#define VAR_VERIFIER 388
#define VAR_VERIFIER_COUNT 389
#define VAR_VERIFIER_FEED_ZONE 390
#define VAR_VERIFIER_TIMEOUT 391

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 47 "./configparser.y" /* yacc.c:355  */

  char *str;
  long long llng;
  int bln;
  struct ip_address_option *ip;
  struct range_option *range;
  struct cpu_option *cpu;
  char **strv;
  struct component *comp;

#line 434 "configparser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE c_lval;

int c_parse (void);

#endif /* !YY_C_CONFIGPARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 451 "configparser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   451

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  137
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  45
/* YYNRULES -- Number of rules.  */
#define YYNRULES  190
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  330

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   391

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   220,   220,   222,   225,   226,   227,   228,   229,   230,
     231,   232,   235,   238,   238,   242,   241,   258,   266,   268,
     270,   272,   274,   276,   278,   280,   282,   284,   286,   288,
     290,   292,   301,   303,   305,   335,   337,   339,   347,   349,
     351,   353,   355,   357,   359,   361,   363,   370,   372,   374,
     376,   378,   380,   382,   384,   386,   388,   390,   392,   402,
     408,   414,   424,   434,   440,   442,   444,   449,   454,   459,
     461,   463,   465,   467,   469,   476,   478,   480,   482,   484,
     486,   488,   492,   522,   523,   526,   553,   555,   560,   561,
     595,   597,   608,   611,   611,   614,   616,   618,   620,   622,
     624,   626,   628,   633,   636,   636,   639,   641,   651,   659,
     661,   663,   665,   671,   670,   692,   692,   695,   706,   710,
     714,   718,   726,   725,   750,   750,   753,   765,   773,   792,
     791,   816,   816,   819,   832,   836,   835,   852,   852,   855,
     862,   865,   871,   873,   875,   883,   885,   888,   887,   899,
     898,   910,   920,   925,   934,   939,   944,   949,   954,   959,
     964,   969,   974,   979,   991,   996,  1001,  1006,  1011,  1013,
    1015,  1017,  1021,  1024,  1024,  1027,  1029,  1039,  1046,  1048,
    1050,  1052,  1054,  1058,  1078,  1079,  1097,  1107,  1116,  1124,
    1125
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "VAR_SERVER",
  "VAR_SERVER_COUNT", "VAR_IP_ADDRESS", "VAR_IP_TRANSPARENT",
  "VAR_IP_FREEBIND", "VAR_REUSEPORT", "VAR_SEND_BUFFER_SIZE",
  "VAR_RECEIVE_BUFFER_SIZE", "VAR_DEBUG_MODE", "VAR_IP4_ONLY",
  "VAR_IP6_ONLY", "VAR_DO_IP4", "VAR_DO_IP6", "VAR_PORT",
  "VAR_USE_SYSTEMD", "VAR_VERBOSITY", "VAR_USERNAME", "VAR_CHROOT",
  "VAR_ZONESDIR", "VAR_ZONELISTFILE", "VAR_DATABASE", "VAR_LOGFILE",
  "VAR_LOG_ONLY_SYSLOG", "VAR_PIDFILE", "VAR_DIFFFILE", "VAR_XFRDFILE",
  "VAR_XFRDIR", "VAR_HIDE_VERSION", "VAR_HIDE_IDENTITY", "VAR_VERSION",
  "VAR_IDENTITY", "VAR_NSID", "VAR_TCP_COUNT", "VAR_TCP_REJECT_OVERFLOW",
  "VAR_TCP_QUERY_COUNT", "VAR_TCP_TIMEOUT", "VAR_TCP_MSS",
  "VAR_OUTGOING_TCP_MSS", "VAR_IPV4_EDNS_SIZE", "VAR_IPV6_EDNS_SIZE",
  "VAR_STATISTICS", "VAR_XFRD_RELOAD_TIMEOUT", "VAR_LOG_TIME_ASCII",
  "VAR_ROUND_ROBIN", "VAR_MINIMAL_RESPONSES", "VAR_CONFINE_TO_ZONE",
  "VAR_REFUSE_ANY", "VAR_ZONEFILES_CHECK", "VAR_ZONEFILES_WRITE",
  "VAR_RRL_SIZE", "VAR_RRL_RATELIMIT", "VAR_RRL_SLIP",
  "VAR_RRL_IPV4_PREFIX_LENGTH", "VAR_RRL_IPV6_PREFIX_LENGTH",
  "VAR_RRL_WHITELIST_RATELIMIT", "VAR_TLS_SERVICE_KEY",
  "VAR_TLS_SERVICE_PEM", "VAR_TLS_SERVICE_OCSP", "VAR_TLS_PORT",
  "VAR_TLS_CERT_BUNDLE", "VAR_CPU_AFFINITY", "VAR_XFRD_CPU_AFFINITY",
  "VAR_SERVER_CPU_AFFINITY", "VAR_DROP_UPDATES", "VAR_XFRD_TCP_MAX",
  "VAR_XFRD_TCP_PIPELINE", "VAR_DNSTAP", "VAR_DNSTAP_ENABLE",
  "VAR_DNSTAP_SOCKET_PATH", "VAR_DNSTAP_SEND_IDENTITY",
  "VAR_DNSTAP_SEND_VERSION", "VAR_DNSTAP_IDENTITY", "VAR_DNSTAP_VERSION",
  "VAR_DNSTAP_LOG_AUTH_QUERY_MESSAGES",
  "VAR_DNSTAP_LOG_AUTH_RESPONSE_MESSAGES", "VAR_REMOTE_CONTROL",
  "VAR_CONTROL_ENABLE", "VAR_CONTROL_INTERFACE", "VAR_CONTROL_PORT",
  "VAR_SERVER_KEY_FILE", "VAR_SERVER_CERT_FILE", "VAR_CONTROL_KEY_FILE",
  "VAR_CONTROL_CERT_FILE", "VAR_KEY", "VAR_ALGORITHM", "VAR_SECRET",
  "VAR_TLS_AUTH", "VAR_TLS_AUTH_DOMAIN_NAME", "VAR_TLS_AUTH_CLIENT_CERT",
  "VAR_TLS_AUTH_CLIENT_KEY", "VAR_TLS_AUTH_CLIENT_KEY_PW", "VAR_PATTERN",
  "VAR_NAME", "VAR_ZONEFILE", "VAR_NOTIFY", "VAR_PROVIDE_XFR",
  "VAR_ALLOW_QUERY", "VAR_AXFR", "VAR_UDP", "VAR_NOTIFY_RETRY",
  "VAR_ALLOW_NOTIFY", "VAR_REQUEST_XFR", "VAR_ALLOW_AXFR_FALLBACK",
  "VAR_OUTGOING_INTERFACE", "VAR_ANSWER_COOKIE", "VAR_COOKIE_SECRET",
  "VAR_COOKIE_SECRET_FILE", "VAR_MAX_REFRESH_TIME", "VAR_MIN_REFRESH_TIME",
  "VAR_MAX_RETRY_TIME", "VAR_MIN_RETRY_TIME", "VAR_MIN_EXPIRE_TIME",
  "VAR_MULTI_MASTER_CHECK", "VAR_SIZE_LIMIT_XFR", "VAR_ZONESTATS",
  "VAR_INCLUDE_PATTERN", "VAR_STORE_IXFR", "VAR_IXFR_SIZE",
  "VAR_IXFR_NUMBER", "VAR_CREATE_IXFR", "VAR_ZONE", "VAR_RRL_WHITELIST",
  "VAR_SERVERS", "VAR_BINDTODEVICE", "VAR_SETFIB", "VAR_VERIFY",
  "VAR_ENABLE", "VAR_VERIFY_ZONE", "VAR_VERIFY_ZONES", "VAR_VERIFIER",
  "VAR_VERIFIER_COUNT", "VAR_VERIFIER_FEED_ZONE", "VAR_VERIFIER_TIMEOUT",
  "$accept", "blocks", "block", "server", "server_block", "server_option",
  "$@1", "socket_options", "socket_option", "cpus", "service_cpu_affinity",
  "dnstap", "dnstap_block", "dnstap_option", "remote_control",
  "remote_control_block", "remote_control_option", "tls_auth", "$@2",
  "tls_auth_block", "tls_auth_option", "key", "$@3", "key_block",
  "key_option", "zone", "$@4", "zone_block", "zone_option", "pattern",
  "$@5", "pattern_block", "pattern_option", "pattern_or_zone_option",
  "$@6", "$@7", "verify", "verify_block", "verify_option", "command",
  "arguments", "ip_address", "number", "boolean", "tlsauth_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391
};
# endif

#define YYPACT_NINF -161

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-161)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -161,    53,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
     335,   -41,   -36,  -161,  -161,  -161,  -161,     3,     0,     9,
      13,    13,    13,     0,     0,    13,    13,    13,    13,    13,
       0,    13,     0,    14,    16,    18,    25,    48,    49,    13,
      55,    57,    61,    62,    13,    13,    63,    65,    68,     0,
      13,     0,     0,     0,     0,     0,     0,     0,     0,    13,
      13,    13,    13,    13,    13,     0,     0,     0,     0,     0,
       0,     0,    69,    72,    74,     0,    75,  -161,  -161,  -161,
      13,     0,     0,    13,    76,    78,  -161,     0,    13,    89,
      13,    13,    90,    92,    13,    13,  -161,    13,     9,     0,
     100,   101,   102,   104,  -161,   -74,    23,   176,   315,     9,
       0,    13,    13,   105,     0,    13,     0,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
     108,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,   117,   118,   119,  -161,   121,   122,   123,
     124,   125,  -161,   126,   128,   131,   139,   141,     0,   143,
       8,    13,   146,     0,     0,     0,     0,   147,    13,     0,
     148,   149,    13,     0,     0,    13,   150,    13,   105,    13,
       0,  -161,  -161,   151,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,   152,   153,   154,
    -161,   155,   156,   157,   158,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,   159,  -101,  -161,  -161,
    -161,  -161,  -161,   160,   161,  -161,   162,    13,     0,  -161,
     163,  -161,  -161,  -161,  -161,  -161,  -161,  -161,   163,  -161
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,    14,    94,   105,   122,   113,   135,   129,
     174,     3,     4,     5,     6,     8,     7,    10,     9,    11,
      12,    92,   103,   125,   116,   138,   132,   172,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    88,    90,    91,
       0,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    93,     0,     0,     0,
       0,     0,     0,     0,   104,   123,   114,   136,   130,     0,
       0,     0,     0,     0,     0,     0,     0,   173,   187,    17,
     186,    15,   188,    18,    19,    47,    20,    21,    22,    27,
      28,    29,    30,    46,    23,    57,    50,    49,    51,    52,
      31,    35,    36,    45,    53,    54,    55,    24,    25,    33,
      32,    34,    37,    38,    39,    40,    41,    42,    43,    44,
      48,    56,    66,    67,    68,    69,    70,    64,    65,    58,
      59,    60,    61,    62,    63,    71,    73,    72,    74,    75,
      81,    26,    79,    80,    76,    77,    78,    82,    95,    96,
      97,    98,    99,   100,   101,   102,   106,   107,   108,   109,
     110,   111,   112,     0,     0,     0,   124,     0,     0,     0,
       0,     0,   115,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,   140,     0,   131,   134,   176,   177,   175,   178,
     184,   179,   180,   182,   181,    83,    89,   127,   128,   126,
     118,   119,   120,   121,   117,   139,   142,     0,     0,     0,
     158,     0,     0,     0,     0,   157,   156,   159,   160,   161,
     162,   163,   145,   144,   143,   146,   164,   165,   166,   167,
     141,   168,   169,   170,   171,   133,   183,    16,   153,   154,
     155,   152,   147,     0,     0,   185,     0,     0,     0,    84,
     189,   149,   151,    85,    86,    87,   190,   148,   189,   150
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,  -161,
    -161,  -161,  -161,   -62,  -161,  -161,  -161,  -161,  -161,   -81,
    -161,  -106,    21,   -31,  -160
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    11,    12,    20,    96,   265,   307,   319,   190,
      97,    13,    21,   106,    14,    22,   114,    15,    24,   116,
     222,    16,    23,   115,   216,    17,    26,   118,   254,    18,
      25,   117,   251,   252,   320,   328,    19,    27,   127,   261,
     306,   131,   129,   133,   327
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
     134,   135,   207,   128,   138,   139,   140,   141,   142,   119,
     144,   282,   130,   256,   213,   214,   132,   146,   152,   147,
     120,   148,   215,   157,   158,   316,   317,   318,   149,   163,
      98,    99,   100,   101,   102,   103,   104,   105,   172,   173,
     174,   175,   176,   177,   107,   108,   109,   110,   111,   112,
     113,   150,   151,     2,   136,   137,   255,     3,   153,   191,
     154,   143,   194,   145,   155,   156,   159,   198,   160,   200,
     201,   161,   185,   204,   205,   186,   206,   187,   189,   195,
     162,   196,   164,   165,   166,   167,   168,   169,   170,   171,
     258,   259,   199,   202,   263,   203,   178,   179,   180,   181,
     182,   183,   184,   209,   210,   211,   188,   212,   260,   283,
     284,   266,   192,   193,   217,   218,   219,   220,   197,   221,
     267,   268,   269,     4,   270,   271,   272,   273,   274,   275,
     208,   276,     5,   121,   277,   122,   123,   124,   125,   126,
       6,   257,   278,     7,   279,   262,   281,   264,     8,   286,
     291,   294,   295,   300,   305,   308,   309,   310,   311,   312,
     313,   314,   315,   321,   322,   323,   326,   302,   329,     0,
       0,     0,     0,     0,     0,     0,     0,     9,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     285,     0,     0,     0,     0,     0,     0,   292,     0,     0,
       0,   296,     0,     0,   299,     0,   301,     0,   303,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   280,
       0,     0,     0,     0,   287,   288,   289,   290,     0,     0,
     293,     0,     0,     0,   297,   298,     0,     0,     0,     0,
       0,   304,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,     0,   324,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
       0,   246,     0,     0,     0,     0,     0,   247,     0,   248,
       0,   249,   250,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   325,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,     0,     0,     0,     0,     0,
       0,   253,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,     0,     0,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
     246,     0,     0,    93,    94,    95,   247,     0,   248,     0,
     249,   250
};

static const yytype_int16 yycheck[] =
{
      31,    32,   108,     3,    35,    36,    37,    38,    39,     6,
      41,     3,     3,   119,    88,    89,     3,     3,    49,     3,
      17,     3,    96,    54,    55,   126,   127,   128,     3,    60,
      71,    72,    73,    74,    75,    76,    77,    78,    69,    70,
      71,    72,    73,    74,    80,    81,    82,    83,    84,    85,
      86,     3,     3,     0,    33,    34,   118,     4,     3,    90,
       3,    40,    93,    42,     3,     3,     3,    98,     3,   100,
     101,     3,     3,   104,   105,     3,   107,     3,     3,     3,
      59,     3,    61,    62,    63,    64,    65,    66,    67,    68,
     121,   122,     3,     3,   125,     3,    75,    76,    77,    78,
      79,    80,    81,     3,     3,     3,    85,     3,     3,   101,
     102,     3,    91,    92,    91,    92,    93,    94,    97,    96,
       3,     3,     3,    70,     3,     3,     3,     3,     3,     3,
     109,     3,    79,   130,     3,   132,   133,   134,   135,   136,
      87,   120,     3,    90,     3,   124,     3,   126,    95,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,   248,   328,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,
      -1,   242,    -1,    -1,   245,    -1,   247,    -1,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,    -1,    -1,   233,   234,   235,   236,    -1,    -1,
     239,    -1,    -1,    -1,   243,   244,    -1,    -1,    -1,    -1,
      -1,   250,    96,    97,    98,    99,   100,    -1,    -1,   103,
     104,   105,   106,   107,    -1,    -1,   317,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
      -1,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,
      -1,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   318,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    98,    99,   100,    -1,    -1,   103,   104,
     105,   106,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,    -1,
     125,    -1,    -1,   108,   109,   110,   131,    -1,   133,    -1,
     135,   136
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   138,     0,     4,    70,    79,    87,    90,    95,   124,
     129,   139,   140,   148,   151,   154,   158,   162,   166,   173,
     141,   149,   152,   159,   155,   167,   163,   174,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,   108,   109,   110,   142,   147,    71,    72,
      73,    74,    75,    76,    77,    78,   150,    80,    81,    82,
      83,    84,    85,    86,   153,   160,   156,   168,   164,     6,
      17,   130,   132,   133,   134,   135,   136,   175,     3,   179,
       3,   178,     3,   180,   180,   180,   179,   179,   180,   180,
     180,   180,   180,   179,   180,   179,     3,     3,     3,     3,
       3,     3,   180,     3,     3,     3,     3,   180,   180,     3,
       3,     3,   179,   180,   179,   179,   179,   179,   179,   179,
     179,   179,   180,   180,   180,   180,   180,   180,   179,   179,
     179,   179,   179,   179,   179,     3,     3,     3,   179,     3,
     146,   180,   179,   179,   180,     3,     3,   179,   180,     3,
     180,   180,     3,     3,   180,   180,   180,   178,   179,     3,
       3,     3,     3,    88,    89,    96,   161,    91,    92,    93,
      94,    96,   157,    96,    97,    98,    99,   100,   103,   104,
     105,   106,   107,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   125,   131,   133,   135,
     136,   169,   170,    96,   165,   170,   178,   179,   180,   180,
       3,   176,   179,   180,   179,   143,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     179,     3,     3,   101,   102,   180,     3,   179,   179,   179,
     179,     3,   180,   179,     3,     3,   180,   179,   179,   180,
       3,   180,   176,   180,   179,     3,   177,   144,     3,     3,
       3,     3,     3,     3,     3,     3,   126,   127,   128,   145,
     171,     3,     3,     3,   180,   179,     3,   181,   172,   181
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   137,   138,   138,   139,   139,   139,   139,   139,   139,
     139,   139,   140,   141,   141,   143,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   144,   144,   145,   145,   145,   146,   146,
     147,   147,   148,   149,   149,   150,   150,   150,   150,   150,
     150,   150,   150,   151,   152,   152,   153,   153,   153,   153,
     153,   153,   153,   155,   154,   156,   156,   157,   157,   157,
     157,   157,   159,   158,   160,   160,   161,   161,   161,   163,
     162,   164,   164,   165,   165,   167,   166,   168,   168,   169,
     169,   170,   170,   170,   170,   170,   170,   171,   170,   172,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   173,   174,   174,   175,   175,   175,   175,   175,
     175,   175,   175,   176,   177,   177,   178,   179,   180,   181,
     181
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     0,     0,     4,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     2,     2,     2,     0,     2,
       1,     1,     2,     2,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     2,     2,     2,
       2,     2,     2,     0,     3,     2,     0,     2,     2,     2,
       2,     2,     0,     3,     2,     0,     2,     2,     2,     0,
       3,     2,     0,     2,     1,     0,     3,     2,     0,     2,
       1,     2,     2,     2,     2,     2,     2,     0,     5,     0,
       6,     4,     3,     3,     3,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     2,     1,     1,     1,     0,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 15:
#line 242 "./configparser.y" /* yacc.c:1648  */
    {
        struct ip_address_option *ip = cfg_parser->opt->ip_addresses;

        if(ip == NULL) {
          cfg_parser->opt->ip_addresses = (yyvsp[0].ip);
        } else {
          while(ip->next) { ip = ip->next; }
          ip->next = (yyvsp[0].ip);
        }

        cfg_parser->ip = (yyvsp[0].ip);
      }
#line 1856 "configparser.c" /* yacc.c:1648  */
    break;

  case 16:
#line 255 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->ip = NULL;
    }
#line 1864 "configparser.c" /* yacc.c:1648  */
    break;

  case 17:
#line 259 "./configparser.y" /* yacc.c:1648  */
    {
      if ((yyvsp[0].llng) > 0) {
        cfg_parser->opt->server_count = (int)(yyvsp[0].llng);
      } else {
        yyerror("expected a number greater than zero");
      }
    }
#line 1876 "configparser.c" /* yacc.c:1648  */
    break;

  case 18:
#line 267 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->ip_transparent = (yyvsp[0].bln); }
#line 1882 "configparser.c" /* yacc.c:1648  */
    break;

  case 19:
#line 269 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->ip_freebind = (yyvsp[0].bln); }
#line 1888 "configparser.c" /* yacc.c:1648  */
    break;

  case 20:
#line 271 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->send_buffer_size = (int)(yyvsp[0].llng); }
#line 1894 "configparser.c" /* yacc.c:1648  */
    break;

  case 21:
#line 273 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->receive_buffer_size = (int)(yyvsp[0].llng); }
#line 1900 "configparser.c" /* yacc.c:1648  */
    break;

  case 22:
#line 275 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->debug_mode = (yyvsp[0].bln); }
#line 1906 "configparser.c" /* yacc.c:1648  */
    break;

  case 23:
#line 277 "./configparser.y" /* yacc.c:1648  */
    { /* ignored, deprecated */ }
#line 1912 "configparser.c" /* yacc.c:1648  */
    break;

  case 24:
#line 279 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->hide_version = (yyvsp[0].bln); }
#line 1918 "configparser.c" /* yacc.c:1648  */
    break;

  case 25:
#line 281 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->hide_identity = (yyvsp[0].bln); }
#line 1924 "configparser.c" /* yacc.c:1648  */
    break;

  case 26:
#line 283 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->drop_updates = (yyvsp[0].bln); }
#line 1930 "configparser.c" /* yacc.c:1648  */
    break;

  case 27:
#line 285 "./configparser.y" /* yacc.c:1648  */
    { if((yyvsp[0].bln)) { cfg_parser->opt->do_ip4 = 1; cfg_parser->opt->do_ip6 = 0; } }
#line 1936 "configparser.c" /* yacc.c:1648  */
    break;

  case 28:
#line 287 "./configparser.y" /* yacc.c:1648  */
    { if((yyvsp[0].bln)) { cfg_parser->opt->do_ip4 = 0; cfg_parser->opt->do_ip6 = 1; } }
#line 1942 "configparser.c" /* yacc.c:1648  */
    break;

  case 29:
#line 289 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->do_ip4 = (yyvsp[0].bln); }
#line 1948 "configparser.c" /* yacc.c:1648  */
    break;

  case 30:
#line 291 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->do_ip6 = (yyvsp[0].bln); }
#line 1954 "configparser.c" /* yacc.c:1648  */
    break;

  case 31:
#line 293 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->opt->database = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      if(cfg_parser->opt->database[0] == 0 &&
         cfg_parser->opt->zonefiles_write == 0)
      {
        cfg_parser->opt->zonefiles_write = ZONEFILES_WRITE_INTERVAL;
      }
    }
#line 1967 "configparser.c" /* yacc.c:1648  */
    break;

  case 32:
#line 302 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->identity = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 1973 "configparser.c" /* yacc.c:1648  */
    break;

  case 33:
#line 304 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->version = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 1979 "configparser.c" /* yacc.c:1648  */
    break;

  case 34:
#line 306 "./configparser.y" /* yacc.c:1648  */
    {
      unsigned char* nsid = 0;
      size_t nsid_len = strlen((yyvsp[0].str));

      if (strncasecmp((yyvsp[0].str), "ascii_", 6) == 0) {
        nsid_len -= 6; /* discard "ascii_" */
        if(nsid_len < 65535) {
          cfg_parser->opt->nsid = region_alloc(cfg_parser->opt->region, nsid_len*2+1);
          hex_ntop((uint8_t*)(yyvsp[0].str)+6, nsid_len, (char*)cfg_parser->opt->nsid, nsid_len*2+1);
        } else {
          yyerror("NSID too long");
        }
      } else if (nsid_len % 2 != 0) {
        yyerror("the NSID must be a hex string of an even length.");
      } else {
        nsid_len = nsid_len / 2;
        if(nsid_len < 65535) {
          nsid = xalloc(nsid_len);
          if (hex_pton((yyvsp[0].str), nsid, nsid_len) == -1) {
            yyerror("hex string cannot be parsed in NSID.");
          } else {
            cfg_parser->opt->nsid = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
          }
          free(nsid);
        } else {
          yyerror("NSID too long");
        }
      }
    }
#line 2013 "configparser.c" /* yacc.c:1648  */
    break;

  case 35:
#line 336 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->logfile = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2019 "configparser.c" /* yacc.c:1648  */
    break;

  case 36:
#line 338 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->log_only_syslog = (yyvsp[0].bln); }
#line 2025 "configparser.c" /* yacc.c:1648  */
    break;

  case 37:
#line 340 "./configparser.y" /* yacc.c:1648  */
    {
      if ((yyvsp[0].llng) > 0) {
        cfg_parser->opt->tcp_count = (int)(yyvsp[0].llng);
      } else {
        yyerror("expected a number greater than zero");
      }
    }
#line 2037 "configparser.c" /* yacc.c:1648  */
    break;

  case 38:
#line 348 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tcp_reject_overflow = (yyvsp[0].bln); }
#line 2043 "configparser.c" /* yacc.c:1648  */
    break;

  case 39:
#line 350 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tcp_query_count = (int)(yyvsp[0].llng); }
#line 2049 "configparser.c" /* yacc.c:1648  */
    break;

  case 40:
#line 352 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tcp_timeout = (int)(yyvsp[0].llng); }
#line 2055 "configparser.c" /* yacc.c:1648  */
    break;

  case 41:
#line 354 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tcp_mss = (int)(yyvsp[0].llng); }
#line 2061 "configparser.c" /* yacc.c:1648  */
    break;

  case 42:
#line 356 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->outgoing_tcp_mss = (int)(yyvsp[0].llng); }
#line 2067 "configparser.c" /* yacc.c:1648  */
    break;

  case 43:
#line 358 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->ipv4_edns_size = (size_t)(yyvsp[0].llng); }
#line 2073 "configparser.c" /* yacc.c:1648  */
    break;

  case 44:
#line 360 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->ipv6_edns_size = (size_t)(yyvsp[0].llng); }
#line 2079 "configparser.c" /* yacc.c:1648  */
    break;

  case 45:
#line 362 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->pidfile = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2085 "configparser.c" /* yacc.c:1648  */
    break;

  case 46:
#line 364 "./configparser.y" /* yacc.c:1648  */
    {
      /* port number, stored as a string */
      char buf[16];
      (void)snprintf(buf, sizeof(buf), "%lld", (yyvsp[0].llng));
      cfg_parser->opt->port = region_strdup(cfg_parser->opt->region, buf);
    }
#line 2096 "configparser.c" /* yacc.c:1648  */
    break;

  case 47:
#line 371 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->reuseport = (yyvsp[0].bln); }
#line 2102 "configparser.c" /* yacc.c:1648  */
    break;

  case 48:
#line 373 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->statistics = (int)(yyvsp[0].llng); }
#line 2108 "configparser.c" /* yacc.c:1648  */
    break;

  case 49:
#line 375 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->chroot = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2114 "configparser.c" /* yacc.c:1648  */
    break;

  case 50:
#line 377 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->username = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2120 "configparser.c" /* yacc.c:1648  */
    break;

  case 51:
#line 379 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->zonesdir = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2126 "configparser.c" /* yacc.c:1648  */
    break;

  case 52:
#line 381 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->zonelistfile = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2132 "configparser.c" /* yacc.c:1648  */
    break;

  case 53:
#line 383 "./configparser.y" /* yacc.c:1648  */
    { /* ignored, deprecated */ }
#line 2138 "configparser.c" /* yacc.c:1648  */
    break;

  case 54:
#line 385 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->xfrdfile = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2144 "configparser.c" /* yacc.c:1648  */
    break;

  case 55:
#line 387 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->xfrdir = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2150 "configparser.c" /* yacc.c:1648  */
    break;

  case 56:
#line 389 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->xfrd_reload_timeout = (int)(yyvsp[0].llng); }
#line 2156 "configparser.c" /* yacc.c:1648  */
    break;

  case 57:
#line 391 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verbosity = (int)(yyvsp[0].llng); }
#line 2162 "configparser.c" /* yacc.c:1648  */
    break;

  case 58:
#line 393 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      if ((yyvsp[0].llng) > 0) {
        cfg_parser->opt->rrl_size = (size_t)(yyvsp[0].llng);
      } else {
        yyerror("expected a number greater than zero");
      }
#endif
    }
#line 2176 "configparser.c" /* yacc.c:1648  */
    break;

  case 59:
#line 403 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      cfg_parser->opt->rrl_ratelimit = (size_t)(yyvsp[0].llng);
#endif
    }
#line 2186 "configparser.c" /* yacc.c:1648  */
    break;

  case 60:
#line 409 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      cfg_parser->opt->rrl_slip = (size_t)(yyvsp[0].llng);
#endif
    }
#line 2196 "configparser.c" /* yacc.c:1648  */
    break;

  case 61:
#line 415 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      if ((yyvsp[0].llng) > 32) {
        yyerror("invalid IPv4 prefix length");
      } else {
        cfg_parser->opt->rrl_ipv4_prefix_length = (size_t)(yyvsp[0].llng);
      }
#endif
    }
#line 2210 "configparser.c" /* yacc.c:1648  */
    break;

  case 62:
#line 425 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      if ((yyvsp[0].llng) > 64) {
        yyerror("invalid IPv6 prefix length");
      } else {
        cfg_parser->opt->rrl_ipv6_prefix_length = (size_t)(yyvsp[0].llng);
      }
#endif
    }
#line 2224 "configparser.c" /* yacc.c:1648  */
    break;

  case 63:
#line 435 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      cfg_parser->opt->rrl_whitelist_ratelimit = (size_t)(yyvsp[0].llng);
#endif
    }
#line 2234 "configparser.c" /* yacc.c:1648  */
    break;

  case 64:
#line 441 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->zonefiles_check = (yyvsp[0].bln); }
#line 2240 "configparser.c" /* yacc.c:1648  */
    break;

  case 65:
#line 443 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->zonefiles_write = (int)(yyvsp[0].llng); }
#line 2246 "configparser.c" /* yacc.c:1648  */
    break;

  case 66:
#line 445 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->opt->log_time_ascii = (yyvsp[0].bln);
      log_time_asc = cfg_parser->opt->log_time_ascii;
    }
#line 2255 "configparser.c" /* yacc.c:1648  */
    break;

  case 67:
#line 450 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->opt->round_robin = (yyvsp[0].bln);
      round_robin = cfg_parser->opt->round_robin;
    }
#line 2264 "configparser.c" /* yacc.c:1648  */
    break;

  case 68:
#line 455 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->opt->minimal_responses = (yyvsp[0].bln);
      minimal_responses = cfg_parser->opt->minimal_responses;
    }
#line 2273 "configparser.c" /* yacc.c:1648  */
    break;

  case 69:
#line 460 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->confine_to_zone = (yyvsp[0].bln); }
#line 2279 "configparser.c" /* yacc.c:1648  */
    break;

  case 70:
#line 462 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->refuse_any = (yyvsp[0].bln); }
#line 2285 "configparser.c" /* yacc.c:1648  */
    break;

  case 71:
#line 464 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tls_service_key = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2291 "configparser.c" /* yacc.c:1648  */
    break;

  case 72:
#line 466 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tls_service_ocsp = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2297 "configparser.c" /* yacc.c:1648  */
    break;

  case 73:
#line 468 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tls_service_pem = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2303 "configparser.c" /* yacc.c:1648  */
    break;

  case 74:
#line 470 "./configparser.y" /* yacc.c:1648  */
    {
      /* port number, stored as string */
      char buf[16];
      (void)snprintf(buf, sizeof(buf), "%lld", (yyvsp[0].llng));
      cfg_parser->opt->tls_port = region_strdup(cfg_parser->opt->region, buf);
    }
#line 2314 "configparser.c" /* yacc.c:1648  */
    break;

  case 75:
#line 477 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->tls_cert_bundle = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2320 "configparser.c" /* yacc.c:1648  */
    break;

  case 76:
#line 479 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->answer_cookie = (yyvsp[0].bln); }
#line 2326 "configparser.c" /* yacc.c:1648  */
    break;

  case 77:
#line 481 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->cookie_secret = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2332 "configparser.c" /* yacc.c:1648  */
    break;

  case 78:
#line 483 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->cookie_secret_file = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2338 "configparser.c" /* yacc.c:1648  */
    break;

  case 79:
#line 485 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->xfrd_tcp_max = (int)(yyvsp[0].llng); }
#line 2344 "configparser.c" /* yacc.c:1648  */
    break;

  case 80:
#line 487 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->xfrd_tcp_pipeline = (int)(yyvsp[0].llng); }
#line 2350 "configparser.c" /* yacc.c:1648  */
    break;

  case 81:
#line 489 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->opt->cpu_affinity = (yyvsp[0].cpu);
    }
#line 2358 "configparser.c" /* yacc.c:1648  */
    break;

  case 82:
#line 493 "./configparser.y" /* yacc.c:1648  */
    {
      if((yyvsp[0].llng) < 0) {
        yyerror("expected a non-negative number");
        YYABORT;
      } else {
        struct cpu_map_option *opt, *tail;

        opt = cfg_parser->opt->service_cpu_affinity;
        while(opt && opt->service != (yyvsp[-1].llng)) { opt = opt->next; }

        if(opt) {
          opt->cpu = (yyvsp[0].llng);
        } else {
          opt = region_alloc_zero(cfg_parser->opt->region, sizeof(*opt));
          opt->service = (int)(yyvsp[-1].llng);
          opt->cpu = (int)(yyvsp[0].llng);

          tail = cfg_parser->opt->service_cpu_affinity;
          if(tail) {
            while(tail->next) { tail = tail->next; }
            tail->next = opt;
          } else {
            cfg_parser->opt->service_cpu_affinity = opt;
          }
        }
      }
    }
#line 2390 "configparser.c" /* yacc.c:1648  */
    break;

  case 85:
#line 527 "./configparser.y" /* yacc.c:1648  */
    {
      char *tok, *ptr, *str;
      struct range_option *servers = NULL;
      long long first, last;

      /* user may specify "0 1", "0" "1", 0 1 or a combination thereof */
      for(str = (yyvsp[0].str); (tok = strtok_r(str, " \t", &ptr)); str = NULL) {
        struct range_option *opt =
          region_alloc(cfg_parser->opt->region, sizeof(*opt));
        first = last = 0;
        if(!parse_range(tok, &first, &last)) {
          yyerror("invalid server range '%s'", tok);
          YYABORT;
        }
        assert(first >= 0);
        assert(last >= 0);
        opt->next = NULL;
        opt->first = (int)first;
        opt->last = (int)last;
        if(servers) {
          servers = servers->next = opt;
        } else {
          servers = cfg_parser->ip->servers = opt;
        }
      }
    }
#line 2421 "configparser.c" /* yacc.c:1648  */
    break;

  case 86:
#line 554 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->ip->dev = (yyvsp[0].bln); }
#line 2427 "configparser.c" /* yacc.c:1648  */
    break;

  case 87:
#line 556 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->ip->fib = (yyvsp[0].llng); }
#line 2433 "configparser.c" /* yacc.c:1648  */
    break;

  case 88:
#line 560 "./configparser.y" /* yacc.c:1648  */
    { (yyval.cpu) = NULL; }
#line 2439 "configparser.c" /* yacc.c:1648  */
    break;

  case 89:
#line 562 "./configparser.y" /* yacc.c:1648  */
    {
      char *tok, *ptr, *str;
      struct cpu_option *tail;
      long long cpu;

      str = (yyvsp[0].str);
      (yyval.cpu) = tail = (yyvsp[-1].cpu);
      if(tail) {
        while(tail->next) { tail = tail->next; }
      }

      /* Users may specify "0 1", "0" "1", 0 1 or a combination thereof. */
      for(str = (yyvsp[0].str); (tok = strtok_r(str, " \t", &ptr)); str = NULL) {
        struct cpu_option *opt =
          region_alloc_zero(cfg_parser->opt->region, sizeof(*opt));
        cpu = 0;
        if(!parse_number(tok, &cpu) || cpu < 0) {
          yyerror("expected a positive number");
          YYABORT;
        }
        assert(cpu >=0);
        opt->cpu = (int)cpu;
        if(tail) {
          tail->next = opt;
          tail = opt;
        } else {
          (yyval.cpu) = tail = opt;
        }
      }
    }
#line 2474 "configparser.c" /* yacc.c:1648  */
    break;

  case 90:
#line 596 "./configparser.y" /* yacc.c:1648  */
    { (yyval.llng) = -1; }
#line 2480 "configparser.c" /* yacc.c:1648  */
    break;

  case 91:
#line 598 "./configparser.y" /* yacc.c:1648  */
    {
      if((yyvsp[0].llng) <= 0) {
        yyerror("invalid server identifier");
        YYABORT;
      }
      (yyval.llng) = (yyvsp[0].llng);
    }
#line 2492 "configparser.c" /* yacc.c:1648  */
    break;

  case 95:
#line 615 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_enable = (yyvsp[0].bln); }
#line 2498 "configparser.c" /* yacc.c:1648  */
    break;

  case 96:
#line 617 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_socket_path = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2504 "configparser.c" /* yacc.c:1648  */
    break;

  case 97:
#line 619 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_send_identity = (yyvsp[0].bln); }
#line 2510 "configparser.c" /* yacc.c:1648  */
    break;

  case 98:
#line 621 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_send_version = (yyvsp[0].bln); }
#line 2516 "configparser.c" /* yacc.c:1648  */
    break;

  case 99:
#line 623 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_identity = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2522 "configparser.c" /* yacc.c:1648  */
    break;

  case 100:
#line 625 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_version = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2528 "configparser.c" /* yacc.c:1648  */
    break;

  case 101:
#line 627 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_log_auth_query_messages = (yyvsp[0].bln); }
#line 2534 "configparser.c" /* yacc.c:1648  */
    break;

  case 102:
#line 629 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->dnstap_log_auth_response_messages = (yyvsp[0].bln); }
#line 2540 "configparser.c" /* yacc.c:1648  */
    break;

  case 106:
#line 640 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->control_enable = (yyvsp[0].bln); }
#line 2546 "configparser.c" /* yacc.c:1648  */
    break;

  case 107:
#line 642 "./configparser.y" /* yacc.c:1648  */
    {
      struct ip_address_option *ip = cfg_parser->opt->control_interface;
      if(ip == NULL) {
        cfg_parser->opt->control_interface = (yyvsp[0].ip);
      } else {
        while(ip->next != NULL) { ip = ip->next; }
        ip->next = (yyvsp[0].ip);
      }
    }
#line 2560 "configparser.c" /* yacc.c:1648  */
    break;

  case 108:
#line 652 "./configparser.y" /* yacc.c:1648  */
    {
      if((yyvsp[0].llng) == 0) {
        yyerror("control port number expected");
      } else {
        cfg_parser->opt->control_port = (int)(yyvsp[0].llng);
      }
    }
#line 2572 "configparser.c" /* yacc.c:1648  */
    break;

  case 109:
#line 660 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->server_key_file = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2578 "configparser.c" /* yacc.c:1648  */
    break;

  case 110:
#line 662 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->server_cert_file = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2584 "configparser.c" /* yacc.c:1648  */
    break;

  case 111:
#line 664 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->control_key_file = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2590 "configparser.c" /* yacc.c:1648  */
    break;

  case 112:
#line 666 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->control_cert_file = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2596 "configparser.c" /* yacc.c:1648  */
    break;

  case 113:
#line 671 "./configparser.y" /* yacc.c:1648  */
    {
        tls_auth_options_type *tls_auth = tls_auth_options_create(cfg_parser->opt->region);
        assert(cfg_parser->tls_auth == NULL);
        cfg_parser->tls_auth = tls_auth;
      }
#line 2606 "configparser.c" /* yacc.c:1648  */
    break;

  case 114:
#line 677 "./configparser.y" /* yacc.c:1648  */
    {
      struct tls_auth_options *tls_auth = cfg_parser->tls_auth;
      if(tls_auth->name == NULL) {
        yyerror("tls-auth has no name");
      } else if(tls_auth->auth_domain_name == NULL) {
        yyerror("tls-auth %s has no auth-domain-name", tls_auth->name);
      } else if(tls_auth_options_find(cfg_parser->opt, tls_auth->name)) {
        yyerror("duplicate tls-auth %s", tls_auth->name);
      } else {
      	tls_auth_options_insert(cfg_parser->opt, tls_auth);
        cfg_parser->tls_auth = NULL;
      }
    }
#line 2624 "configparser.c" /* yacc.c:1648  */
    break;

  case 117:
#line 696 "./configparser.y" /* yacc.c:1648  */
    {
      dname_type *dname;
      dname = (dname_type *)dname_parse(cfg_parser->opt->region, (yyvsp[0].str));
      cfg_parser->tls_auth->name = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      if(dname == NULL) {
        yyerror("bad tls-auth name %s", (yyvsp[0].str));
      } else {
        region_recycle(cfg_parser->opt->region, dname, dname_total_size(dname));
      }
    }
#line 2639 "configparser.c" /* yacc.c:1648  */
    break;

  case 118:
#line 707 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->tls_auth->auth_domain_name = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
    }
#line 2647 "configparser.c" /* yacc.c:1648  */
    break;

  case 119:
#line 711 "./configparser.y" /* yacc.c:1648  */
    {
	    cfg_parser->tls_auth->client_cert = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
    }
#line 2655 "configparser.c" /* yacc.c:1648  */
    break;

  case 120:
#line 715 "./configparser.y" /* yacc.c:1648  */
    {
	    cfg_parser->tls_auth->client_key = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
    }
#line 2663 "configparser.c" /* yacc.c:1648  */
    break;

  case 121:
#line 719 "./configparser.y" /* yacc.c:1648  */
    {
	    cfg_parser->tls_auth->client_key_pw = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
    }
#line 2671 "configparser.c" /* yacc.c:1648  */
    break;

  case 122:
#line 726 "./configparser.y" /* yacc.c:1648  */
    {
        key_options_type *key = key_options_create(cfg_parser->opt->region);
        key->algorithm = region_strdup(cfg_parser->opt->region, "sha256");
        assert(cfg_parser->key == NULL);
        cfg_parser->key = key;
      }
#line 2682 "configparser.c" /* yacc.c:1648  */
    break;

  case 123:
#line 733 "./configparser.y" /* yacc.c:1648  */
    {
      struct key_options *key = cfg_parser->key;
      if(key->name == NULL) {
        yyerror("tsig key has no name");
      } else if(key->algorithm == NULL) {
        yyerror("tsig key %s has no algorithm", key->name);
      } else if(key->secret == NULL) {
        yyerror("tsig key %s has no secret blob", key->name);
      } else if(key_options_find(cfg_parser->opt, key->name)) {
        yyerror("duplicate tsig key %s", key->name);
      } else {
        key_options_insert(cfg_parser->opt, key);
        cfg_parser->key = NULL;
      }
    }
#line 2702 "configparser.c" /* yacc.c:1648  */
    break;

  case 126:
#line 754 "./configparser.y" /* yacc.c:1648  */
    {
      dname_type *dname;

      dname = (dname_type *)dname_parse(cfg_parser->opt->region, (yyvsp[0].str));
      cfg_parser->key->name = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      if(dname == NULL) {
        yyerror("bad tsig key name %s", (yyvsp[0].str));
      } else {
        region_recycle(cfg_parser->opt->region, dname, dname_total_size(dname));
      }
    }
#line 2718 "configparser.c" /* yacc.c:1648  */
    break;

  case 127:
#line 766 "./configparser.y" /* yacc.c:1648  */
    {
      if(tsig_get_algorithm_by_name((yyvsp[0].str)) == NULL) {
        yyerror("bad tsig key algorithm %s", (yyvsp[0].str));
      } else {
        cfg_parser->key->algorithm = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      }
    }
#line 2730 "configparser.c" /* yacc.c:1648  */
    break;

  case 128:
#line 774 "./configparser.y" /* yacc.c:1648  */
    {
      uint8_t data[16384];
      int size;

      cfg_parser->key->secret = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      size = b64_pton((yyvsp[0].str), data, sizeof(data));
      if(size == -1) {
        yyerror("cannot base64 decode tsig secret %s",
          cfg_parser->key->name?
          cfg_parser->key->name:"");
      } else if(size != 0) {
        memset(data, 0xdd, size); /* wipe secret */
      }
    }
#line 2749 "configparser.c" /* yacc.c:1648  */
    break;

  case 129:
#line 792 "./configparser.y" /* yacc.c:1648  */
    {
        assert(cfg_parser->pattern == NULL);
        assert(cfg_parser->zone == NULL);
        cfg_parser->zone = zone_options_create(cfg_parser->opt->region);
        cfg_parser->zone->part_of_config = 1;
        cfg_parser->zone->pattern = cfg_parser->pattern =
          pattern_options_create(cfg_parser->opt->region);
        cfg_parser->zone->pattern->implicit = 1;
      }
#line 2763 "configparser.c" /* yacc.c:1648  */
    break;

  case 130:
#line 802 "./configparser.y" /* yacc.c:1648  */
    {
      assert(cfg_parser->zone != NULL);
      if(cfg_parser->zone->name == NULL) {
        yyerror("zone has no name");
      } else if(!nsd_options_insert_zone(cfg_parser->opt, cfg_parser->zone)) {
        yyerror("duplicate zone %s", cfg_parser->zone->name);
      } else if(!nsd_options_insert_pattern(cfg_parser->opt, cfg_parser->zone->pattern)) {
        yyerror("duplicate pattern %s", cfg_parser->zone->pattern->pname);
      }
      cfg_parser->pattern = NULL;
      cfg_parser->zone = NULL;
    }
#line 2780 "configparser.c" /* yacc.c:1648  */
    break;

  case 133:
#line 820 "./configparser.y" /* yacc.c:1648  */
    {
      const char *marker = PATTERN_IMPLICIT_MARKER;
      char *pname = region_alloc(cfg_parser->opt->region, strlen((yyvsp[0].str)) + strlen(marker) + 1);
      memmove(pname, marker, strlen(marker));
      memmove(pname + strlen(marker), (yyvsp[0].str), strlen((yyvsp[0].str)) + 1);
      cfg_parser->zone->pattern->pname = pname;
      cfg_parser->zone->name = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      if(pattern_options_find(cfg_parser->opt, pname)) {
        yyerror("zone %s cannot be created because implicit pattern %s "
                    "already exists", (yyvsp[0].str), pname);
      }
    }
#line 2797 "configparser.c" /* yacc.c:1648  */
    break;

  case 135:
#line 836 "./configparser.y" /* yacc.c:1648  */
    {
        assert(cfg_parser->pattern == NULL);
        cfg_parser->pattern = pattern_options_create(cfg_parser->opt->region);
      }
#line 2806 "configparser.c" /* yacc.c:1648  */
    break;

  case 136:
#line 841 "./configparser.y" /* yacc.c:1648  */
    {
      pattern_options_type *pattern = cfg_parser->pattern;
      if(pattern->pname == NULL) {
        yyerror("pattern has no name");
      } else if(!nsd_options_insert_pattern(cfg_parser->opt, pattern)) {
        yyerror("duplicate pattern %s", pattern->pname);
      }
      cfg_parser->pattern = NULL;
    }
#line 2820 "configparser.c" /* yacc.c:1648  */
    break;

  case 139:
#line 856 "./configparser.y" /* yacc.c:1648  */
    {
      if(strchr((yyvsp[0].str), ' ')) {
        yyerror("space is not allowed in pattern name: '%s'", (yyvsp[0].str));
      }
      cfg_parser->pattern->pname = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
    }
#line 2831 "configparser.c" /* yacc.c:1648  */
    break;

  case 141:
#line 866 "./configparser.y" /* yacc.c:1648  */
    {
#ifdef RATELIMIT
      cfg_parser->pattern->rrl_whitelist |= rrlstr2type((yyvsp[0].str));
#endif
    }
#line 2841 "configparser.c" /* yacc.c:1648  */
    break;

  case 142:
#line 872 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->zonefile = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2847 "configparser.c" /* yacc.c:1648  */
    break;

  case 143:
#line 874 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->zonestats = region_strdup(cfg_parser->opt->region, (yyvsp[0].str)); }
#line 2853 "configparser.c" /* yacc.c:1648  */
    break;

  case 144:
#line 876 "./configparser.y" /* yacc.c:1648  */
    {
      if((yyvsp[0].llng) > 0) {
        cfg_parser->pattern->size_limit_xfr = (int)(yyvsp[0].llng);
      } else {
        yyerror("expected a number greater than zero");
      }
    }
#line 2865 "configparser.c" /* yacc.c:1648  */
    break;

  case 145:
#line 884 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->multi_master_check = (int)(yyvsp[0].bln); }
#line 2871 "configparser.c" /* yacc.c:1648  */
    break;

  case 146:
#line 886 "./configparser.y" /* yacc.c:1648  */
    { config_apply_pattern(cfg_parser->pattern, (yyvsp[0].str)); }
#line 2877 "configparser.c" /* yacc.c:1648  */
    break;

  case 147:
#line 888 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      if(acl->blocked)
        yyerror("blocked address used for request-xfr");
      if(acl->rangetype != acl_range_single)
        yyerror("address range used for request-xfr");
      append_acl(&cfg_parser->pattern->request_xfr, acl);
    }
#line 2890 "configparser.c" /* yacc.c:1648  */
    break;

  case 148:
#line 897 "./configparser.y" /* yacc.c:1648  */
    { }
#line 2896 "configparser.c" /* yacc.c:1648  */
    break;

  case 149:
#line 899 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      acl->use_axfr_only = 1;
      if(acl->blocked)
        yyerror("blocked address used for request-xfr");
      if(acl->rangetype != acl_range_single)
        yyerror("address range used for request-xfr");
      append_acl(&cfg_parser->pattern->request_xfr, acl);
    }
#line 2910 "configparser.c" /* yacc.c:1648  */
    break;

  case 150:
#line 909 "./configparser.y" /* yacc.c:1648  */
    { }
#line 2916 "configparser.c" /* yacc.c:1648  */
    break;

  case 151:
#line 911 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      acl->allow_udp = 1;
      if(acl->blocked)
        yyerror("blocked address used for request-xfr");
      if(acl->rangetype != acl_range_single)
        yyerror("address range used for request-xfr");
      append_acl(&cfg_parser->pattern->request_xfr, acl);
    }
#line 2930 "configparser.c" /* yacc.c:1648  */
    break;

  case 152:
#line 921 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      append_acl(&cfg_parser->pattern->allow_notify, acl);
    }
#line 2939 "configparser.c" /* yacc.c:1648  */
    break;

  case 153:
#line 926 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      if(acl->blocked)
        yyerror("blocked address used for notify");
      if(acl->rangetype != acl_range_single)
        yyerror("address range used for notify");
      append_acl(&cfg_parser->pattern->notify, acl);
    }
#line 2952 "configparser.c" /* yacc.c:1648  */
    break;

  case 154:
#line 935 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      append_acl(&cfg_parser->pattern->provide_xfr, acl);
    }
#line 2961 "configparser.c" /* yacc.c:1648  */
    break;

  case 155:
#line 940 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[-1].str), (yyvsp[0].str));
      append_acl(&cfg_parser->pattern->allow_query, acl);
    }
#line 2970 "configparser.c" /* yacc.c:1648  */
    break;

  case 156:
#line 945 "./configparser.y" /* yacc.c:1648  */
    {
      acl_options_type *acl = parse_acl_info(cfg_parser->opt->region, (yyvsp[0].str), "NOKEY");
      append_acl(&cfg_parser->pattern->outgoing_interface, acl);
    }
#line 2979 "configparser.c" /* yacc.c:1648  */
    break;

  case 157:
#line 950 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->allow_axfr_fallback = (yyvsp[0].bln);
      cfg_parser->pattern->allow_axfr_fallback_is_default = 0;
    }
#line 2988 "configparser.c" /* yacc.c:1648  */
    break;

  case 158:
#line 955 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->notify_retry = (yyvsp[0].llng);
      cfg_parser->pattern->notify_retry_is_default = 0;
    }
#line 2997 "configparser.c" /* yacc.c:1648  */
    break;

  case 159:
#line 960 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->max_refresh_time = (yyvsp[0].llng);
      cfg_parser->pattern->max_refresh_time_is_default = 0;
    }
#line 3006 "configparser.c" /* yacc.c:1648  */
    break;

  case 160:
#line 965 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->min_refresh_time = (yyvsp[0].llng);
      cfg_parser->pattern->min_refresh_time_is_default = 0;
    }
#line 3015 "configparser.c" /* yacc.c:1648  */
    break;

  case 161:
#line 970 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->max_retry_time = (yyvsp[0].llng);
      cfg_parser->pattern->max_retry_time_is_default = 0;
    }
#line 3024 "configparser.c" /* yacc.c:1648  */
    break;

  case 162:
#line 975 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->min_retry_time = (yyvsp[0].llng);
      cfg_parser->pattern->min_retry_time_is_default = 0;
    }
#line 3033 "configparser.c" /* yacc.c:1648  */
    break;

  case 163:
#line 980 "./configparser.y" /* yacc.c:1648  */
    {
      long long num;
      uint8_t expr;

      if (!parse_expire_expr((yyvsp[0].str), &num, &expr)) {
        yyerror("expected an expire time in seconds or \"refresh+retry+1\"");
        YYABORT; /* trigger a parser error */
      }
      cfg_parser->pattern->min_expire_time = num;
      cfg_parser->pattern->min_expire_time_expr = expr;
    }
#line 3049 "configparser.c" /* yacc.c:1648  */
    break;

  case 164:
#line 992 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->store_ixfr = (yyvsp[0].bln);
      cfg_parser->pattern->store_ixfr_is_default = 0;
    }
#line 3058 "configparser.c" /* yacc.c:1648  */
    break;

  case 165:
#line 997 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->ixfr_size = (yyvsp[0].llng);
      cfg_parser->pattern->ixfr_size_is_default = 0;
    }
#line 3067 "configparser.c" /* yacc.c:1648  */
    break;

  case 166:
#line 1002 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->ixfr_number = (yyvsp[0].llng);
      cfg_parser->pattern->ixfr_number_is_default = 0;
    }
#line 3076 "configparser.c" /* yacc.c:1648  */
    break;

  case 167:
#line 1007 "./configparser.y" /* yacc.c:1648  */
    {
      cfg_parser->pattern->create_ixfr = (yyvsp[0].bln);
      cfg_parser->pattern->create_ixfr_is_default = 0;
    }
#line 3085 "configparser.c" /* yacc.c:1648  */
    break;

  case 168:
#line 1012 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->verify_zone = (yyvsp[0].bln); }
#line 3091 "configparser.c" /* yacc.c:1648  */
    break;

  case 169:
#line 1014 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->verifier = (yyvsp[0].strv); }
#line 3097 "configparser.c" /* yacc.c:1648  */
    break;

  case 170:
#line 1016 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->verifier_feed_zone = (yyvsp[0].bln); }
#line 3103 "configparser.c" /* yacc.c:1648  */
    break;

  case 171:
#line 1018 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->pattern->verifier_timeout = (yyvsp[0].llng); }
#line 3109 "configparser.c" /* yacc.c:1648  */
    break;

  case 175:
#line 1028 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verify_enable = (yyvsp[0].bln); }
#line 3115 "configparser.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1030 "./configparser.y" /* yacc.c:1648  */
    {
      struct ip_address_option *ip = cfg_parser->opt->verify_ip_addresses;
      if(!ip) {
        cfg_parser->opt->verify_ip_addresses = (yyvsp[0].ip);
      } else {
        while(ip->next) { ip = ip->next; }
        ip->next = (yyvsp[0].ip);
      }
    }
#line 3129 "configparser.c" /* yacc.c:1648  */
    break;

  case 177:
#line 1040 "./configparser.y" /* yacc.c:1648  */
    {
      /* port number, stored as a string */
      char buf[16];
      (void)snprintf(buf, sizeof(buf), "%lld", (yyvsp[0].llng));
      cfg_parser->opt->verify_port = region_strdup(cfg_parser->opt->region, buf);
    }
#line 3140 "configparser.c" /* yacc.c:1648  */
    break;

  case 178:
#line 1047 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verify_zones = (yyvsp[0].bln); }
#line 3146 "configparser.c" /* yacc.c:1648  */
    break;

  case 179:
#line 1049 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verifier = (yyvsp[0].strv); }
#line 3152 "configparser.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1051 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verifier_count = (int)(yyvsp[0].llng); }
#line 3158 "configparser.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1053 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verifier_timeout = (int)(yyvsp[0].llng); }
#line 3164 "configparser.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1055 "./configparser.y" /* yacc.c:1648  */
    { cfg_parser->opt->verifier_feed_zone = (yyvsp[0].bln); }
#line 3170 "configparser.c" /* yacc.c:1648  */
    break;

  case 183:
#line 1059 "./configparser.y" /* yacc.c:1648  */
    {
      char **argv;
      size_t argc = 1;
      for(struct component *i = (yyvsp[0].comp); i; i = i->next) {
        argc++;
      }
      argv = region_alloc_zero(
        cfg_parser->opt->region, (argc + 1) * sizeof(char *));
      argc = 0;
      argv[argc++] = (yyvsp[-1].str);
      for(struct component *j, *i = (yyvsp[0].comp); i; i = j) {
        j = i->next;
        argv[argc++] = i->str;
        region_recycle(cfg_parser->opt->region, i, sizeof(*i));
      }
      (yyval.strv) = argv;
    }
#line 3192 "configparser.c" /* yacc.c:1648  */
    break;

  case 184:
#line 1078 "./configparser.y" /* yacc.c:1648  */
    { (yyval.comp) = NULL; }
#line 3198 "configparser.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1080 "./configparser.y" /* yacc.c:1648  */
    {
      struct component *comp = region_alloc_zero(
        cfg_parser->opt->region, sizeof(*comp));
      comp->str = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      if((yyvsp[-1].comp)) {
        struct component *tail = (yyvsp[-1].comp);
        while(tail->next) {
         tail = tail->next;
        }
        tail->next = comp;
        (yyval.comp) = (yyvsp[-1].comp);
      } else {
        (yyval.comp) = comp;
      }
    }
#line 3218 "configparser.c" /* yacc.c:1648  */
    break;

  case 186:
#line 1098 "./configparser.y" /* yacc.c:1648  */
    {
      struct ip_address_option *ip = region_alloc_zero(
        cfg_parser->opt->region, sizeof(*ip));
      ip->address = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
      ip->fib = -1;
      (yyval.ip) = ip;
    }
#line 3230 "configparser.c" /* yacc.c:1648  */
    break;

  case 187:
#line 1108 "./configparser.y" /* yacc.c:1648  */
    {
      if(!parse_number((yyvsp[0].str), &(yyval.llng))) {
        yyerror("expected a number");
        YYABORT; /* trigger a parser error */
      }
    }
#line 3241 "configparser.c" /* yacc.c:1648  */
    break;

  case 188:
#line 1117 "./configparser.y" /* yacc.c:1648  */
    {
      if(!parse_boolean((yyvsp[0].str), &(yyval.bln))) {
        yyerror("expected yes or no");
        YYABORT; /* trigger a parser error */
      }
    }
#line 3252 "configparser.c" /* yacc.c:1648  */
    break;

  case 190:
#line 1126 "./configparser.y" /* yacc.c:1648  */
    { char *tls_auth_name = region_strdup(cfg_parser->opt->region, (yyvsp[0].str));
	  add_to_last_acl(&cfg_parser->pattern->request_xfr, tls_auth_name);}
#line 3259 "configparser.c" /* yacc.c:1648  */
    break;


#line 3263 "configparser.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1129 "./configparser.y" /* yacc.c:1907  */


static void
append_acl(struct acl_options **list, struct acl_options *acl)
{
	assert(list != NULL);

	if(*list == NULL) {
		*list = acl;
	} else {
		struct acl_options *tail = *list;
		while(tail->next != NULL)
			tail = tail->next;
		tail->next = acl;
	}
}

static void
add_to_last_acl(struct acl_options **list, char *tls_auth_name)
{
	struct acl_options *tail = *list;
	assert(list != NULL);
	assert(*list != NULL);
	while(tail->next != NULL)
		tail = tail->next;
	tail->tls_auth_name = tls_auth_name;
}

static int
parse_boolean(const char *str, int *bln)
{
	if(strcmp(str, "yes") == 0) {
		*bln = 1;
	} else if(strcmp(str, "no") == 0) {
		*bln = 0;
	} else {
		return 0;
	}

	return 1;
}

static int
parse_expire_expr(const char *str, long long *num, uint8_t *expr)
{
	if(parse_number(str, num)) {
		*expr = EXPIRE_TIME_HAS_VALUE;
		return 1;
	}
	if(strcmp(str, REFRESHPLUSRETRYPLUS1_STR) == 0) {
		*num = 0;
		*expr = REFRESHPLUSRETRYPLUS1;
		return 1;
	}
	return 0;
}

static int
parse_number(const char *str, long long *num)
{
	/* ensure string consists entirely of digits */
	size_t pos = 0;
	while(str[pos] >= '0' && str[pos] <= '9') {
		pos++;
	}

	if(pos != 0 && str[pos] == '\0') {
		*num = strtoll(str, NULL, 10);
		return 1;
	}

	return 0;
}

static int
parse_range(const char *str, long long *low, long long *high)
{
	const char *ptr = str;
	long long num[2];

	/* require range to begin with a number */
	if(*ptr < '0' || *ptr > '9') {
		return 0;
	}

	num[0] = strtoll(ptr, (char **)&ptr, 10);

	/* require number to be followed by nothing at all or a dash */
	if(*ptr == '\0') {
		*low = num[0];
		*high = num[0];
		return 1;
	} else if(*ptr != '-') {
		return 0;
	}

	++ptr;
	/* require dash to be followed by a number */
	if(*ptr < '0' || *ptr > '9') {
		return 0;
	}

	num[1] = strtoll(ptr, (char **)&ptr, 10);

	/* require number to be followed by nothing at all */
	if(*ptr == '\0') {
		if(num[0] < num[1]) {
			*low = num[0];
			*high = num[1];
		} else {
			*low = num[1];
			*high = num[0];
		}
		return 1;
	}

	return 0;
}
